'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * ncc自定义档案枚举组件(支持列表型自定义档案)
                                                                                                                                                                                                                                                                   * @author xg
                                                                                                                                                                                                                                                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _yylibUi = require('yylib-ui');

var _ajax = require('yylib-utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;

var uiMeta = {
    name: 'ncc-enumSelect',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('serverUrl', window.EnvConfig.REF_BASE_URL, PropTypes.string, true, '后端服务基准地址'), field('queryUrl', '/nccloud/uapbd/userdef/DefdocGridRef.do', PropTypes.string, false, '数据服务url'), field('pk_defdoclist', '', PropTypes.string, false, 'ncc自定义档案列表主键'), field('condition', {}, PropTypes.object, false, '请求数据时的自定义参数')
    /**其他属性配置请查看YYSelect**/
    ]
};
var NccEnumSelect = _yylibUi.YYClass.create({
    uiMeta: uiMeta,
    displayName: 'NccEnumSelect',
    getInitialState: function getInitialState() {
        return {
            queryUrl: this.props.queryUrl,
            pk_defdoclist: this.props.pk_defdoclist,
            condition: this.props.condition,
            value: this.props.value ? this.props.value : this.props.defaultValue,
            options: []
        };
    },
    componentDidMount: function componentDidMount() {
        this.loadData();
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if ('defaultValue' in nextProps && nextProps.defaultValue !== this.props.defaultValue) {
            this.setState({ value: nextProps.defaultValue });
        }
        //value优先级高于defaultValue
        if ('value' in nextProps && nextProps.value !== this.props.value) {
            this.setState({ value: nextProps.value });
        }
        if ('queryUrl' in nextProps && nextProps.queryUrl !== this.props.queryUrl) {
            this.setState({ queryUrl: nextProps.queryUrl }, this.loadData);
        }
        if ('pk_defdoclist' in nextProps && nextProps.pk_defdoclist !== this.props.pk_defdoclist) {
            this.setState({ pk_defdoclist: nextProps.pk_defdoclist }, this.loadData);
        }
        if ('condition' in nextProps && nextProps.condition !== this.props.condition) {
            this.setState({ condition: nextProps.condition }, this.loadData);
        }
    },

    // 查询数据
    loadData: function loadData() {
        var _this = this;

        var _props$serverUrl = this.props.serverUrl,
            serverUrl = _props$serverUrl === undefined ? window.EnvConfig.REF_BASE_URL : _props$serverUrl;
        var _state = this.state,
            queryUrl = _state.queryUrl,
            pk_defdoclist = _state.pk_defdoclist,
            condition = _state.condition;

        if (!serverUrl || !queryUrl || !pk_defdoclist) {
            return;
        }
        var params = {
            busiParamJson: JSON.stringify({
                pageInfo: { pageSize: 50, pageIndex: 0 },
                queryCondition: Object.assign({}, condition, { pk_defdoclist: pk_defdoclist, icopRefType: 'icopgrid' })
            }),
            sysParamJson: {
                pagecs: _jsCookie2.default.get("cookiets")
            }
        };
        _ajax2.default.request({
            method: 'POST',
            url: serverUrl + queryUrl,
            send: params,
            type: 'json',
            cookies: true,
            noToken: true,
            success: function success(result) {
                if (result && result.success) {
                    var data = result.data && result.data.content ? result.data.content : [];
                    var options = [];
                    // 转成{id:xxx,name:xxx}格式
                    data.map(function (option) {
                        options.push({
                            id: option.refpk,
                            name: option.refname
                        });
                    });
                    _this.setState({ options: options });
                }
            }
        });
    },
    render: function render() {
        return _react2.default.createElement(_yylibUi.YYSelect, _extends({}, this.props, { items: this.state.options, className: this.className(), valueType: 'object',
            valueKey: 'id', textKey: 'name', value: this.state.value }));
    }
});
module.exports = NccEnumSelect;