'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _g = require('@antv/g6');

var _g2 = _interopRequireDefault(_g);

var _yylibUi = require('yylib-ui');

var _ajax = require('yylib-utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

var _NccUrlUtils = require('yylib-utils/NccUrlUtils');

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

var _BillTrackUtil = require('./BillTrackUtil');

var _BillTrackTable = require('./BillTrackTable');

var _BillTrackTable2 = _interopRequireDefault(_BillTrackTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * ncc单据追溯组件内容区
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xg
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var BillTrackContent = function (_React$Component) {
    _inherits(BillTrackContent, _React$Component);

    function BillTrackContent(props) {
        _classCallCheck(this, BillTrackContent);

        var _this = _possibleConstructorReturn(this, (BillTrackContent.__proto__ || Object.getPrototypeOf(BillTrackContent)).call(this, props));

        _this.dataFormat = function (data) {
            return data.map(function (item) {
                var lightBillVO = item.lightBillVO,
                    sourceList = item.sourceList,
                    forwardList = item.forwardList,
                    isForward = item.isForward;
                var billID = lightBillVO.billID,
                    billType = lightBillVO.billType,
                    transtype = lightBillVO.transtype,
                    _lightBillVO$billType = lightBillVO.billTypeName,
                    billTypeName = _lightBillVO$billType === undefined ? '' : _lightBillVO$billType,
                    billCode = lightBillVO.billCode;

                var text = (0, _BillTrackUtil.suitableLabelText)(billTypeName, billCode);
                return {
                    label: text,
                    id: billID,
                    billType: billType,
                    transType: transtype,
                    source: sourceList || [],
                    target: forwardList || [],
                    isForward: isForward,
                    billCode: billCode,
                    billTypeName: billTypeName
                };
            });
        };

        _this.changeSize = function () {
            var _this$state = _this.state,
                graph = _this$state.graph,
                showTable = _this$state.showTable;
            var _this$props = _this.props,
                width = _this$props.width,
                height = _this$props.height;

            if (graph) {
                graph.changeSize(width, !!showTable ? height / 2 : height);
                graph.fitCenter();
            }
        };

        _this.changeColor = function (selectedId, chartData) {
            if (!selectedId) {
                selectedId = _this.state.selectedId;
            }
            chartData.nodes.map(function (node) {
                if (node.id === selectedId) {
                    node.style = {
                        fill: '#CCEAFF'
                    };
                    node.labelCfg = {
                        style: {
                            fill: '#007ACE'
                        }
                    };
                } else {
                    node.style = {
                        fill: '#FFE19D'
                    };
                    node.labelCfg = {
                        style: {
                            fill: '#F87321'
                        }
                    };
                }
                node.style.lineWidth = 1;
                node.style.stroke = "#FFF";
                node.style.radius = 10;
                node.style.cursor = 'pointer';
                node.labelCfg.style.cursor = 'pointer';
            });
            return chartData;
        };

        _this.changeExtract = function () {
            var _this$state2 = _this.state,
                selectedId = _this$state2.selectedId,
                chartData = _this$state2.chartData,
                relatedData = _this$state2.relatedData,
                extract = _this$state2.extract;

            if (extract) {
                relatedData = (0, _BillTrackUtil.getRelated)(selectedId, chartData);
            } else {
                relatedData = null;
            }
            _this.setState({ relatedData: relatedData }, _this.repaint);
        };

        _this.repaint = function () {
            var _this$state3 = _this.state,
                graph = _this$state3.graph,
                relatedData = _this$state3.relatedData,
                chartData = _this$state3.chartData;

            if (graph) {
                graph.data(relatedData ? relatedData : chartData);
                graph.render();
                graph.fitCenter();
            }
        };

        _this.renderChart = function () {
            var _this$state4 = _this.state,
                graph = _this$state4.graph,
                showTable = _this$state4.showTable;

            if (graph) {
                _this.repaint();
                return;
            }
            var _this$props2 = _this.props,
                width = _this$props2.width,
                height = _this$props2.height;

            graph = new _g2.default.Graph({
                container: 'container',
                width: width,
                height: !!showTable ? height / 2 : height,
                minZoom: 0.5,
                maxZoom: 1.5,
                layout: {
                    type: 'dagre',
                    rankdir: 'LR', // 左右方向
                    nodesep: 10, // 节点间距
                    ranksep: 20, // 层级间距
                    controlPoints: true
                },
                defaultNode: {
                    size: [140, 50],
                    type: 'rect'
                },
                defaultEdge: {
                    type: 'polyline',
                    style: {
                        radius: 20,
                        offset: 45,
                        lineWidth: 1,
                        stroke: '#C2C8D5',
                        endArrow: {
                            path: 'M 0,0 L 8,4 L 8,-4 Z',
                            fill: '#C2C8D5'
                        }
                    }
                },
                modes: {
                    default: ['drag-canvas', 'zoom-canvas', 'click-select', {
                        type: 'tooltip',
                        formatText: function formatText(model) {
                            return '<ul class="tooltip">\n\t\t\t\t\t\t\t\t<li>' + '单据名称' + ': ' + model.billTypeName + '</li>\n\t\t\t\t\t\t\t\t<li>' + '单据编号' + ': ' + model.billCode + '</li>\n\t\t\t\t\t\t\t</ul>';
                        },

                        offset: 30
                    }]
                },
                fitCenter: true
            });
            graph.on('node:click', function (ev) {
                var selectedId = ev.item ? ev.item._cfg.id : null;
                if (selectedId && selectedId !== _this.state.selectedId) {
                    var _this$state5 = _this.state,
                        data = _this$state5.data,
                        chartData = _this$state5.chartData;

                    chartData = _this.changeColor(selectedId, chartData);
                    var rows = (0, _BillTrackUtil.getSourceTargetNode)(selectedId, data);
                    _this.setState({
                        selectedId: selectedId,
                        chartData: chartData,
                        tableData: rows,
                        extract: false
                    }, _this.changeExtract);
                }
            });
            graph.on('node:dblclick', function (ev) {
                var selectedId = ev.item ? ev.item._cfg.id : null;
                var chartData = _this.state.chartData;

                if (selectedId) {
                    var node = chartData.nodes.find(function (elem) {
                        return elem.id === selectedId;
                    });
                    if (node) {
                        var billType = node.billType;
                        var transType = node.transType;
                        _this.openBill(selectedId, transType ? transType : billType);
                    }
                }
            });
            graph.data(_this.state.chartData);
            graph.render();
            _this.setState({ graph: graph });
        };

        _this.queryBillFlow = function (callback) {
            var _this$state6 = _this.state,
                billId = _this$state6.billId,
                billType = _this$state6.billType;
            var _this$props3 = _this.props,
                appCode = _this$props3.appCode,
                serverUrl = _this$props3.serverUrl,
                billFlowAction = _this$props3.billFlowAction;

            if (!billId || !billType || !appCode) {
                _yylibUi.YYMessage.error("查询单据上下游失败,缺少必要参数", 3);
                return;
            }
            var params = {
                busiParamJson: JSON.stringify({
                    queryCondition: {
                        bill_PK: billId,
                        bill_type: billType
                    }
                }),
                sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
            };
            _this.setState({ spinning: true });
            _ajax2.default.postJSONWithCookies(serverUrl + billFlowAction, params, function (result) {
                if (result && result.success) {
                    var data = result.data || [];
                    var selectedId = _this.state.selectedId;
                    var chartData = {
                        nodes: _this.dataFormat(data),
                        edges: []
                    };
                    chartData.nodes.forEach(function (item) {
                        var _chartData$edges;

                        return (_chartData$edges = chartData.edges).push.apply(_chartData$edges, _toConsumableArray((0, _BillTrackUtil.createEdges)(item)));
                    });
                    var rows = (0, _BillTrackUtil.getSourceTargetNode)(selectedId, data);
                    chartData = _this.changeColor(selectedId, chartData);
                    _this.setState({ data: data, chartData: chartData, tableData: rows }, _this.renderChart);
                } else {
                    _yylibUi.YYMessage.error("查询单据上下游失败");
                }
            }, function (error) {
                _yylibUi.YYMessage.error("查询单据上下游失败");
            }, function () {
                _this.setState({ spinning: false });
            });
        };

        _this.openBill = function (selectedId, type) {
            if (!selectedId || !type) {
                _yylibUi.YYMessage.error("打开单据失败,缺少必要参数");
                return;
            }
            var appCode = _this.state.appCode;
            var _this$props4 = _this.props,
                serverUrl = _this$props4.serverUrl,
                billFlowUrlAction = _this$props4.billFlowUrlAction;

            var params = {
                busiParamJson: JSON.stringify({
                    billpk: selectedId,
                    billtypecode: type,
                    pagecode: null,
                    sence: '4'
                }),
                sysParamJson: { appcode: appCode, pagecs: _jsCookie2.default.get("cookiets") }
            };
            _this.setState({ spinning: true });
            _ajax2.default.postJSONWithCookies(serverUrl + billFlowUrlAction, params, function (result) {
                if (result.success && result.data && result.data.appPageVO) {
                    var _appCode = result.data.appcode;
                    var pageCode = result.data.appPageVO.pagecode;
                    var pageUrl = result.data.appPageVO.pageurl;
                    (0, _NccUrlUtils.openTo)(pageUrl, {
                        status: 'browse',
                        scene: 'linksce',
                        appcode: _appCode,
                        pagecode: pageCode,
                        id: selectedId
                    });
                } else {
                    _yylibUi.YYMessage.error("查询流程节点对应的单据信息失败");
                }
            }, function () {
                _yylibUi.YYMessage.error("查询流程节点对应的单据信息失败");
            }, function () {
                _this.setState({ spinning: false });
            });
        };

        _this.onExtract = function () {
            _this.setState({ extract: !_this.state.extract }, _this.changeExtract);
        };

        _this.state = {
            graph: null, // 图形实例
            data: _this.props.data || [], // 原始数据
            chartData: { // 图形数据
                nodes: [],
                edges: []
            },
            tableData: [],
            spinning: false, //  是否加载中状态
            appCode: _this.props.appCode, // ncc应用注册编号
            billId: _this.props.billId, // 单据主键
            billType: _this.props.billType, // 单据类型
            selectedId: _this.props.billId || '', // 选中的节点id，页面初加载时选中节点为基本节点,即基于基本节点构建的上下游关系
            extract: _this.props.extract, // 是否是路径抽取状态
            relatedData: null, // 抽取路径后相关联的节点数据，用来渲染路径抽取视图
            showTable: _this.props.showTable //  是否显示表格
        };
        return _this;
    }

    _createClass(BillTrackContent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.queryBillFlow();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if ("showTable" in nextProps && nextProps.showTable !== this.props.showTable) {
                this.setState({ showTable: nextProps.showTable }, this.changeSize);
            }
            if ("billId" in nextProps && nextProps.billId !== this.props.billId || "billType" in nextProps && nextProps.billType !== this.props.billType || "appCode" in nextProps && nextProps.appCode !== this.props.appCode) {
                this.setState({
                    billId: nextProps.billId,
                    billType: nextProps.billType,
                    appCode: nextProps.appCode
                }, this.queryBillFlow);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var graph = this.state.graph;

            if (graph) {
                graph.destroy();
            }
        }

        // 对查询的单据上下游信息进行数据转换


        // 改变canvas大小


        // 改变节点颜色


        // 路径抽取状态变化


        // 重新绘制图形


        // 渲染图形


        // 查询上下游单据数据


        /**
         * 打开业务单据
         * @param selectedId 单据ID
         * @param type 交易类型/单据类型
         */


        // 路径抽取/显示全部

    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                showTable = _state.showTable,
                extract = _state.extract,
                spinning = _state.spinning,
                _state$tableData = _state.tableData,
                tableData = _state$tableData === undefined ? [] : _state$tableData;

            return _react2.default.createElement(
                _yylibUi.YYSpin,
                { spinning: spinning },
                _react2.default.createElement(
                    'div',
                    { className: 'bill-track-content' },
                    _react2.default.createElement(
                        _yylibUi.YYButton,
                        { className: 'extract-btn', onClick: this.onExtract },
                        extract ? '显示全部' : '路径抽取'
                    ),
                    _react2.default.createElement('div', { id: 'container' }),
                    showTable && _react2.default.createElement(_BillTrackTable2.default, _extends({}, this.props, { dataSource: tableData }))
                )
            );
        }
    }]);

    return BillTrackContent;
}(_react2.default.Component);

exports.default = BillTrackContent;


BillTrackContent.defaultProps = {
    appCode: '', // ncc应用注册编号
    billId: '', // 单据主键
    billType: '', // 单据类型编号
    width: 990, // 默认宽度
    height: 512, // 默认高度
    extract: false, // 是否路径抽取状态
    serverUrl: window.EnvConfig.ADDR, // 数据服务基准地址
    billFlowAction: '/nccloud/riart/billFlow/billFlowAction.do', // 查询流程信息的服务地址
    billFlowUrlAction: '/nccloud/riart/billFlow/billFlowUrlAction.do' // 流程节点对应的单据url服务地址
};