'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _yylibUi = require('yylib-ui');

var _immutable = require('immutable');

var _lodash = require('lodash');

var _ajax = require('yylib-utils/ajax');

var _ajax2 = _interopRequireDefault(_ajax);

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./style/index.less');

var _YYEnumSelect = require('../enum/YYEnumSelect');

var _YYEnumSelect2 = _interopRequireDefault(_YYEnumSelect);

var _Url = require('../templates/ijz/IjzSearch/Url');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 定义高级查询
 */
var React = require('react');

var _require = require('antd'),
    Row = _require.Row,
    Col = _require.Col,
    Button = _require.Button,
    Icon = _require.Icon,
    Form = _require.Form,
    Menu = _require.Menu,
    Dropdown = _require.Dropdown,
    Popconfirm = _require.Popconfirm;

var FormItem = Form.Item;

// var NccSearchCondition = require('./NccSearchCondition')
var PropTypes = _yylibUi.YYClass.PropTypes;
var field = _yylibUi.YYClass.field;
var Constant = require('../search/Constant');
var url = require('../search/Resturl');

var FormItemType = require('../widgets/FormItemType');

function noop() {}
//定义META
var uiMeta = {
    name: 'ncc-advanceSearch',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'advance-search', PropTypes.string, false, '样式名前缀'), field('span', 3, PropTypes.number, false, '显示搜索条件数量'), field('expandText', '收起', PropTypes.string, false, '展开时显示的文本'), field('collapseText', '展开', PropTypes.string, false, '折叠时显示的文本'), field('expand', true, PropTypes.bool, false, '是否展开所有查询列表'), field('visible', true, PropTypes.bool, false, '是否显示组件'), field('enableCollapse', true, PropTypes.bool, false, '是否支持折叠'), field('onExpandOrCollapse', null, PropTypes.func, false, "当展开|折叠时的回调，传递参数：'expand'|'collapse'"), field('onSearchClick', noop, PropTypes.func, false, '查询回调'),, field('onCellChange', noop, PropTypes.func, false, '查询条件框值变化')]
};
var NccAdvanceSearch = _yylibUi.YYClass.create({
    uiMeta: uiMeta,
    displayName: 'NccAdvanceSearch',
    getInitialState: function getInitialState() {
        return {
            expand: this.props.expand == true || this.props.expand == 'true',
            _dataSource: [],
            _dataItem: [],
            cellErrors: {},
            _schemeId: null,
            _schemeName: null,
            _schemeList: [],
            totalSpan: 18,
            _visible: false
        };
    },
    componentWillMount: function componentWillMount() {
        // const {findUI} = this.context;
        this.procDataItem();
        this.procSchemeQuery();
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if (!(0, _immutable.is)((0, _immutable.fromJS)(this.props.children), (0, _immutable.fromJS)(nextProps.children))) {
            this.procDataItem(nextProps.children);
        }
        this.setState({
            expand: nextProps.expand
        });
    },
    procDataItem: function procDataItem(value) {
        var _props = this.props,
            children = _props.children,
            enableCollapse = _props.enableCollapse;

        var _dataItem = [],
            _dataSource = [];
        React.Children.map(value || children, function (item) {
            if (React.isValidElement(item)) {
                var inputprops = item.props.inputprops ? _.clone(item.props.inputprops) : {};
                // 下拉选择特殊处理
                if (inputprops && item.props.inputtype === FormItemType.select) {
                    var items = item.props.children ? _.clone(item.props.children) : [];
                    var options = [];
                    if (items && items.length > 0) {
                        _.forEach(items, function (item) {
                            var option = {};
                            option.value = item.value;
                            option.text = item.text || item.children;
                            options.push(option);
                        });
                    }
                    inputprops.items = options;
                }
                _dataItem.push({
                    key: item.props.uikey,
                    fieldkey: item.props.fieldkey || item.props.uikey,
                    title: item.props.title,
                    fieldtype: item.props.fieldtype,
                    inputtype: item.props.inputtype,
                    inputprops: inputprops,
                    oper: item.props.oper || [],
                    enableOrder: item.props.enableOrder === undefined ? false : item.props.enableOrder,
                    enableSearch: item.props.enableSearch === undefined ? true : item.props.enableSearch,
                    hidden: item.props.hidden === undefined ? false : item.props.hidden,
                    required: item.props.required === undefined ? false : item.props.required,
                    readonly: item.props.readonly === undefined ? false : item.props.readonly,
                    presetFunc: item.props.funcId ? {
                        funcId: item.props.funcId,
                        funcCode: item.props.funcCode,
                        funcName: item.props.funcName
                    } : null
                });
                if (item.props.required && _.findIndex(_dataSource, { key: item.props.uikey }) === -1) {
                    _dataSource.push(_extends({}, _dataItem[_dataItem.length - 1], {
                        id: item.props.uikey + '_' + Date.now()
                    }));
                }
            }
        });
        this.setState({
            _dataItem: _dataItem,
            _dataSource: enableCollapse && !this.props.expand ? _dataItem.slice(0, this.props.span) : _dataItem,
            totalSpan: _dataItem.length > 3 && this.props.expand ? 24 : 18
        });
    },

    _createSpan: function _createSpan() {
        return React.createElement(
            'div',
            { className: this.className('collapse') },
            React.createElement(
                'span',
                { onClick: this._onChange },
                this.state.expand ? this.props.expandText : this.props.collapseText
            ),
            React.createElement(Icon, { type: this.state.expand ? "up" : "down", classnames: this.className('collapse-icon') })
        );
    },
    _onChange: function _onChange() {
        var _this = this;

        this.setState({
            expand: !this.state.expand,
            _dataSource: this.state._dataItem
        }, function () {
            _this.setState({
                totalSpan: _this.state.totalSpan / _this.props.span == 6 && _this.state.expand ? 24 : 18
            });
            if (!_this.state.expand) {
                _this.setState({
                    _dataSource: _this.state._dataItem.slice(0, _this.props.span)
                });
            }
        });
        if ((0, _lodash.isFunction)(this.props.onExpandOrCollapse)) {
            this.props.onExpandOrCollapse(this.state.expand ? 'expand' : 'collapse');
        }
    },
    handleSearchClick: function handleSearchClick() {
        var onSearchClick = this.props.onSearchClick;
        var _dataSource = this.state._dataSource;

        var cb = _dataSource.map(function (item) {
            return {
                key: item.key,
                logic: item.oper[0],
                value: item.value,
                inputtype: item.inputtype
            };
        });
        if (this.validate() === true) {
            onSearchClick(cb);
        }
    },
    handleClearClick: function handleClearClick() {
        var dataSource = [];
        this.state._dataSource.map(function (item) {
            delete item.value;
            dataSource.push(item);
        });
        this.setState({ _dataSource: dataSource });
    },
    procSchemeUpdate: function procSchemeUpdate() {
        var _this2 = this;

        var _props2 = this.props,
            areaid = _props2.areaid,
            uiRunMode = _props2.uiRunMode;
        var _state = this.state,
            _dataSource = _state._dataSource,
            _schemeId = _state._schemeId,
            _schemeName = _state._schemeName,
            _schemeList = _state._schemeList;

        var REF_BASE_URL = window.EnvConfig.REF_BASE_URL;
        var otherProps = { isdevelop: false, isquickqs: false };
        if (uiRunMode === 'design') {
            otherProps['isdevelop'] = true;
        }
        if (!!!areaid) {
            _yylibUi.YYMessage.error('方案编号没有配置');
            return;
        }
        if (_schemeList.length === 0) {
            _yylibUi.YYMessage.error('还不存在方案，请新建方案');
            return;
        } else if (!!!_schemeId) {
            _yylibUi.YYMessage.error('选择要保存的方案');
            return;
        }
        _ajax2.default.postJSONEx(REF_BASE_URL + _Url.SchemeUpdate, {
            "busiParamJson": JSON.stringify(_extends({}, otherProps, {
                areaid: areaid,
                name: _schemeName,
                pk_ncc_queryscheme: _schemeId,
                renderobj4web: _dataSource
            })),
            "sysParamJson": { pagecs: _jsCookie2.default.get("cookiets") }
        }, function (result) {
            if (result.success === true) {
                _yylibUi.YYMessage.success('保存方案成功');
                _this2.procSchemeQuery();
            }
        });
    },
    handleUpdateScheme: function handleUpdateScheme() {
        this.procSchemeUpdate();
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },

    // 查询条件api
    renderCompareCol: function renderCompareCol(value, rowData, index, dataIndex) {
        var options = [];
        _.forEach(rowData.oper || [], function (subItem) {
            options.push(React.createElement(
                _yylibUi.YYOption,
                { key: subItem, value: subItem },
                Constant.oper[subItem]
            ));
        });
        return React.createElement(
            _yylibUi.YYSelect,
            {
                defaultValue: (rowData.oper || [])[0],
                value: Constant.oper[value],
                key: rowData.field,
                onChange: this.onCellChange.bind(this, rowData, dataIndex),
                disableClear: true
            },
            options
        );
    },
    renderDataCol: function renderDataCol(value, rowData, index, dataIndex) {
        var cont = React.createElement(_yylibUi.YYInput, { value: '', onChange: this.onCellChange.bind(this, rowData, dataIndex) });
        var inputprops = rowData.inputprops || {};
        var presetFunc = rowData.presetFunc || {};
        var serverUrl = inputprops && inputprops.serverUrl ? inputprops.serverUrl : url.REFER_SEVER_URL;
        // 有预置函数时删除置空提示
        if (presetFunc && inputprops && inputprops.placeholder) {
            delete inputprops.placeholder;
        }
        switch (rowData.inputtype) {
            case FormItemType.input:
                // 文本框
                cont = React.createElement(_yylibUi.YYInput, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.date:
                // 日期
                if (rowData.logic === 'bt') {
                    cont = React.createElement(_yylibUi.YYRangePicker, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                } else {
                    cont = React.createElement(_yylibUi.YYDatePicker, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                }
                break;
            case FormItemType.select:
                // 下拉选择
                cont = React.createElement(_yylibUi.YYSelect, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.inputrefer:
                //  参照
                cont = React.createElement(_yylibUi.YYReferInput, _extends({}, inputprops, {
                    serverUrl: serverUrl,
                    condition: inputprops.condition,
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.switch:
                // 开关
                cont = React.createElement(_yylibUi.YYSwitch, _extends({}, inputprops, {
                    checked: value === null ? inputprops.defaultChecked : value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.enumselect:
                // 档案枚举
                if (!value && inputprops.multiple === true) {
                    value = [];
                }
                cont = React.createElement(_YYEnumSelect2.default, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.number:
                // 数值框
                cont = React.createElement(_yylibUi.YYInputNumber, _extends({}, inputprops, {
                    value: value,
                    type: 'number',
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.currency:
                // 金额框
                cont = React.createElement(_yylibUi.YYInputNumber, _extends({}, inputprops, {
                    value: value,
                    type: 'currency',
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.autoselect:
                // 自动匹配
                cont = React.createElement(_yylibUi.YYAutoSelect, _extends({}, inputprops, {
                    serverUrl: serverUrl,
                    condition: inputprops.condition,
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
        }
        return React.createElement(
            'div',
            null,
            cont
        );
    },
    onCellChange: function onCellChange(rowData, dataIndex) {
        var value = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'value';
        var _dataSource = this.state._dataSource;

        var _value = undefined;
        if (value != null && value != undefined) {
            _value = value.target ? value.target.value : value;
        }
        _dataSource[_.findIndex(_dataSource, { fieldkey: rowData.fieldkey })][dataIndex] = _value;
        this.setState({ _date: Date.now(), cellErrors: {} }, this.props.onCellChange.bind(this, rowData, dataIndex, value));
    },
    validate: function validate() {
        var _dataSource = this.state._dataSource;
        var cellErrors = this.state.cellErrors;

        _.forEach(_dataSource, function (item) {
            if (item.required === true) {
                if (item.value === null || item.value === undefined) {
                    cellErrors[item.uikey] = {};
                }
            }
        });
        this.setState({ _date: Date.now() });
        if (_.isEmpty(cellErrors)) {
            return true;
        } else {
            return false;
        }
    },

    //方案查询
    procSchemeQuery: function procSchemeQuery() {
        var _this3 = this;

        var areaid = this.props.areaid;

        var REF_BASE_URL = window.EnvConfig.REF_BASE_URL;
        // console.log(9999,REF_BASE_URL)
        if (!!!areaid) {
            _yylibUi.YYMessage.error('方案编号没有配置');
            return;
        }
        _ajax2.default.postJSONEx(REF_BASE_URL + _Url.SchemeQuery, {
            "busiParamJson": JSON.stringify({ areaid: areaid }),
            "sysParamJson": { pagecs: _jsCookie2.default.get("cookiets") }
        }, function (result) {
            if (result.success === true) {
                _this3.setState({ _schemeList: result.data || [] });
            }
        });
    },

    // 保存方案
    handleSaveScheme: function handleSaveScheme() {
        // const {_schemeId}=this.state
        // if(_schemeId){
        //     this.procSchemeUpdate()
        // }else{
        //     this.setState({_visible: true});
        // }
        this.procSchemeUpdate();
    },
    handleModalOk: function handleModalOk() {
        this.setState({ _visible: false });
        this.procSchemeAdd();
    },
    handleModalCancel: function handleModalCancel() {
        this.setState({ _visible: false });
    },

    // 新增方案
    procSchemeAdd: function procSchemeAdd() {
        var _this4 = this;

        var _props3 = this.props,
            areaid = _props3.areaid,
            uiRunMode = _props3.uiRunMode;
        var _state2 = this.state,
            _dataSource = _state2._dataSource,
            _schemeName = _state2._schemeName;

        var REF_BASE_URL = window.EnvConfig.REF_BASE_URL;
        var otherProps = { name: _schemeName, isdevelop: false, isquickqs: false };
        if (uiRunMode === 'design') {
            otherProps['isdevelop'] = true;
        }
        if (!!!areaid) {
            _yylibUi.YYMessage.error('方案编号没有配置');
            return;
        }
        _ajax2.default.postJSONEx(REF_BASE_URL + _Url.SchemeAdd, {
            "busiParamJson": JSON.stringify(_extends({}, otherProps, { areaid: areaid, renderobj4web: _dataSource })),
            "sysParamJson": { pagecs: _jsCookie2.default.get("cookiets") }
        }, function (result) {
            if (result.success === true) {
                _yylibUi.YYMessage.success('新增方案成功');
                _this4.procSchemeQuery();
            }
        });
    },

    // 删除方案
    procSchemeDel: function procSchemeDel() {
        var _this5 = this;

        var _schemeId = this.state._schemeId;
        var uiRunMode = this.props.uiRunMode;

        var REF_BASE_URL = window.EnvConfig.REF_BASE_URL;
        var otherProps = { isdevelop: false, isquickqs: false };
        if (uiRunMode === 'design') {
            otherProps['isdevelop'] = true;
        }
        _ajax2.default.postJSONEx(REF_BASE_URL + _Url.SchemeDelete, {
            "busiParamJson": JSON.stringify(_extends({}, otherProps, {
                pk_ncc_queryscheme: _schemeId
            })),
            "sysParamJson": { pagecs: _jsCookie2.default.get("cookiets") }
        }, function (result) {
            _this5.procSchemeQuery();
        });
    },
    handleSchemeClick: function handleSchemeClick(key) {
        var _state3 = this.state,
            _schemeList = _state3._schemeList,
            _schemeId = _state3._schemeId,
            enableCollapse = _state3.enableCollapse,
            _dataItem = _state3._dataItem;

        if (key == _schemeId) {
            this.setState({
                _schemeId: null,
                _dataSource: enableCollapse && !this.props.expand ? _dataItem.slice(0, this.props.span) : _dataItem
            });
            return;
        }
        var scheme = _.find(_schemeList, { pk_ncc_queryscheme: key });
        this.setState({ _dataSource: scheme.renderobj4web, _schemeId: key, _schemeName: scheme.name });
    },
    handleChange: function handleChange(tag, checked) {
        var _this6 = this;

        var selectedTags = this.state.selectedTags;

        var nextSelectedTags = checked ? [tag] : selectedTags.filter(function (t) {
            return t !== tag;
        });
        this.setState({ selectedTags: nextSelectedTags }, function () {
            _this6.handleSchemeClick(tag);
        });
    },
    render: function render() {
        var _this7 = this;

        var _state4 = this.state,
            _state4$_dataItem = _state4._dataItem,
            _dataItem = _state4$_dataItem === undefined ? [] : _state4$_dataItem,
            _state4$_dataSource = _state4._dataSource,
            _dataSource = _state4$_dataSource === undefined ? [] : _state4$_dataSource,
            totalSpan = _state4.totalSpan,
            _schemeList = _state4._schemeList,
            selectedTags = _state4.selectedTags,
            _schemeId = _state4._schemeId;

        var _props4 = this.props,
            visible = _props4.visible,
            enableCollapse = _props4.enableCollapse;

        var span = this._createSpan();
        var menu = React.createElement(
            Menu,
            null,
            React.createElement(
                Menu.Item,
                null,
                React.createElement(
                    'span',
                    { onClick: this.handleSaveScheme },
                    '\u4FDD\u5B58\u65B9\u6848'
                )
            ),
            React.createElement(
                Menu.Item,
                null,
                React.createElement(
                    'span',
                    { onClick: function onClick() {
                            _this7.setState({ _visible: true });
                        } },
                    '\u53E6\u5B58\u65B9\u6848'
                )
            ),
            React.createElement(
                Menu.Item,
                null,
                React.createElement(
                    Popconfirm,
                    {
                        title: '\u786E\u5B9A\u5220\u9664\u65B9\u6848\u5417',
                        onConfirm: this.procSchemeDel.bind(this),
                        okText: '\u786E\u5B9A',
                        cancelText: '\u53D6\u6D88'
                    },
                    React.createElement(
                        'span',
                        null,
                        '\u5220\u9664\u65B9\u6848'
                    )
                )
            )
        );
        return React.createElement(
            'div',
            { className: this.className() },
            React.createElement(
                Row,
                { className: this.className() + '-schemeList' },
                _schemeList.map(function (v, index) {
                    return React.createElement(
                        Col,
                        {
                            span: 4,
                            onClick: _this7.handleSchemeClick.bind(_this7, v.pk_ncc_queryscheme),
                            className: _this7.className() + '-schemeListItem',
                            style: {
                                background: _schemeId == v.pk_ncc_queryscheme ? '#E24D47' : '#fff',
                                borderColor: _schemeId == v.pk_ncc_queryscheme ? '#E24D47' : '#d9d9d9',
                                color: _schemeId == v.pk_ncc_queryscheme ? '#fff' : '#666666'
                            }
                        },
                        v.name
                    );
                })
            ),
            visible && React.createElement(
                'div',
                null,
                React.createElement(
                    Row,
                    { className: this.className() + '-condition', type: 'flex' },
                    _dataSource.map(function (v, index) {
                        return React.createElement(
                            Col,
                            { span: totalSpan / _this7.props.span, className: _this7.className() + '-condition-item' },
                            React.createElement(
                                'span',
                                { className: _this7.className() + '-condition-item-label', title: v.title },
                                v.title,
                                ' :'
                            ),
                            React.createElement(
                                'div',
                                { className: _this7.className() + '-condition-item-input' },
                                _this7.renderDataCol(v.value, v, index, 'value')
                            )
                        );
                    }),
                    React.createElement(
                        Col,
                        { className: this.className() + '-action', span: 6 },
                        React.createElement(
                            _yylibUi.YYButton,
                            { type: 'primary', onClick: this.handleSearchClick },
                            '\u67E5\u8BE2'
                        ),
                        React.createElement(
                            _yylibUi.YYButton,
                            { onClick: this.handleClearClick },
                            '\u91CD\u7F6E'
                        ),
                        React.createElement(
                            Dropdown,
                            { overlay: menu, placement: 'bottomLeft' },
                            React.createElement(
                                Button,
                                { type: 'success' },
                                '\u65B9\u6848\u64CD\u4F5C'
                            )
                        ),
                        enableCollapse && _dataItem.length > 3 && span
                    )
                )
            ),
            React.createElement(
                _yylibUi.YYModal,
                {
                    title: '\u4FDD\u5B58\u65B9\u6848', visible: this.state._visible,
                    className: (0, _classnames2.default)(this.getClassName() + '-modal'),
                    onOk: this.handleModalOk,
                    onCancel: this.handleModalCancel
                },
                React.createElement(
                    'span',
                    null,
                    '\u65B9\u6848\u540D\u79F0\uFF1A'
                ),
                React.createElement(_yylibUi.YYInput, { placeholder: '\u597D\u8BB0\u7684\u65B9\u6848\u540D\u79F0', onChange: function onChange(e) {
                        _this7.setState({ _schemeName: e.currentTarget.value });
                    } })
            )
        );
    }
});

module.exports = NccAdvanceSearch;