'use strict';

var React = require('react');
var YYClass = require('../../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Rate = _require.Rate;

var uiMeta = {
    name: 'rate',
    fields: [
    // field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('count', 5, PropTypes.number, false, 'star 总数'), field('value', undefined, PropTypes.number, false, '当前数，受控值'), field('defaultValue', 0, PropTypes.number, false, '默认值'), field('onChange', null, PropTypes.func, false, '回调'), field('allowHalf', false, PropTypes.bool, false, '是否允许半选'), field('disabled', false, PropTypes.bool, false, '只读，无法进行交互')]
};

var YYRate = YYClass.create({
    uiMeta: uiMeta,
    getInitialState: function getInitialState() {
        return {};
    },
    render: function render() {
        return React.createElement(
            'div',
            { className: this.className() },
            React.createElement(
                Rate,
                this.props,
                this.props.children
            )
        );
    }
});
module.exports = YYRate;